
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readImplicitValues();
int checkImplicitValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text1, *text2, *text3, *text4;
    char *text5, *text6;
} 
Text, *TextPtr;


typedef struct _Pass {
    TextPtr text;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateImplicit( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup,  g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label2, g_label3, g_label4;
    Widget    g_label5, g_label6;
    Widget    g_text1,  g_text2, g_text3, g_text4;
    Widget    g_text5,  g_text6;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;
    Widget    g_labelC, g_textC;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Implicit.center.x = 0.0;
    ObjectValues.Obj.Implicit.center.y = 0.0;
    ObjectValues.Obj.Implicit.center.z = 0.0;
    ObjectValues.Obj.Implicit.xy_terms = (char *)malloc(5);
    ObjectValues.Obj.Implicit.xy_terms = "0";
    ObjectValues.Obj.Implicit.xz_terms = (char *)malloc(5);
    ObjectValues.Obj.Implicit.xz_terms = "0";
    ObjectValues.Obj.Implicit.yz_terms = (char *)malloc(5);
    ObjectValues.Obj.Implicit.yz_terms = "0";
    ObjectValues.Obj.Implicit.c_terms = (char *)malloc(5);
    ObjectValues.Obj.Implicit.c_terms = "0";
    ObjectValues.Obj.Implicit.size = 0.20;
    ObjectValues.Obj.Implicit.bounds = 10;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNallowShellResize, True,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Implicit" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "implicit_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_title1,
        NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Implicit.center.x,
       ObjectValues.Obj.Implicit.center.y, ObjectValues.Obj.Implicit.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_labelC,
        XtNlabel, "xy terms",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Implicit.xy_terms );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label1,
        NULL );

    g_label2 = XtVaCreateManagedWidget( "g_label2", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label1,
        XtNlabel, "xz terms",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Implicit.xz_terms );
    text->text2 = XtNewString( buffer );
    g_text2  = XtVaCreateManagedWidget( "g_text2", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text2,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text2),
        XtNfromVert, g_label1,
        XtNfromHoriz, g_label2,
        NULL );

    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label2,
        XtNlabel, "yz terms",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Implicit.yz_terms );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text3,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text3),
        XtNfromVert, g_label2,
        XtNfromHoriz, g_label3,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label3,
        XtNlabel, "c terms",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Implicit.c_terms );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_label3,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label4,
        XtNlabel, "size",
        NULL );
    buffer = (String) malloc( 80 );
    sprintf( buffer, "%f", ObjectValues.Obj.Implicit.size );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    g_label6 = XtVaCreateManagedWidget( "g_label6", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label5,
        XtNlabel, "bounds",
        NULL );
    buffer = (String) malloc( 80 );
    sprintf( buffer, "%d", ObjectValues.Obj.Implicit.bounds );
    text->text6 = XtNewString( buffer );
    g_text6  = XtVaCreateManagedWidget( "g_text6", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text6,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text6),
        XtNfromVert, g_label5,
        XtNfromHoriz, g_label6,
        NULL );

    pass->text = text;

    callbacks[0].callback = (XtCallbackProc) readImplicitValues;
    callbacks[0].closure  = (XtPointer) text;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label6,
        XtNvertDistance, 20,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label6,
        XtNfromHoriz, g_ok,
        XtNvertDistance, 20,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readImplicitValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    TextPtr ptext = (TextPtr) client_data;
    extern char creatingObject;

    Point center;
    char * xy, * xz, * yz, * c;
    double size;
    int bounds;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textC, "%f %f %f", &(center.x), &(center.y), &(center.z) );
    XtFree( ptext->textC );
    xy = (char *)malloc( strlen( ptext->text1 ) + 1 );
    strcpy( xy, ptext->text1 );
    XtFree( ptext->text1 );
    xz = (char *)malloc( strlen( ptext->text2 ) + 1 );
    strcpy( xz, ptext->text2 );
    XtFree( ptext->text2 );
    yz = (char *)malloc( strlen( ptext->text3 ) + 1 );
    strcpy( yz, ptext->text3 );
    XtFree( ptext->text3 );
    c = (char *)malloc( strlen( ptext->text4 ) + 1 );
    strcpy( c, ptext->text4 );
    XtFree( ptext->text4 );
    sscanf( ptext->text5, "%lf", &size );
    XtFree( ptext->text5 );
    sscanf( ptext->text6, "%d", &bounds );
    XtFree( ptext->text6 );

    ObjectValues.Obj.Implicit.center.x = center.x;
    ObjectValues.Obj.Implicit.center.y = center.y;
    ObjectValues.Obj.Implicit.center.z = center.z;
    ObjectValues.Obj.Implicit.xy_terms = (char *)malloc( strlen( xy ) + 1 );
    strcpy( ObjectValues.Obj.Implicit.xy_terms, xy );
    ObjectValues.Obj.Implicit.xz_terms = (char *)malloc( strlen( xz ) + 1 );
    strcpy( ObjectValues.Obj.Implicit.xz_terms, xz );
    ObjectValues.Obj.Implicit.yz_terms = (char *)malloc( strlen( yz ) + 1 );
    strcpy( ObjectValues.Obj.Implicit.yz_terms, yz );
    ObjectValues.Obj.Implicit.c_terms  = (char *)malloc( strlen( c ) + 1 );
    strcpy( ObjectValues.Obj.Implicit.c_terms, c );
    ObjectValues.Obj.Implicit.size = size;
    ObjectValues.Obj.Implicit.bounds = bounds;

    if( !(status = checkImplicitValues( popup, xy, xz, yz, c, center ) ) )
        ImplicitFunction( xy, xz, yz, c, size, bounds, center );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkImplicitValues( w, xy_terms, xz_terms, yz_terms, c_terms, center )
Widget w;
char * xy_terms, xz_terms, yz_terms, c_terms;
Point center;
{
    int errors = 0;

    return errors;
}
